/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.EmpresaRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Empresa extends TableImpl<EmpresaRecord> {

    private static final long serialVersionUID = -1155773213;

    /**
     * The reference instance of <code>public.empresa</code>
     */
    public static final Empresa EMPRESA = new Empresa();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<EmpresaRecord> getRecordType() {
        return EmpresaRecord.class;
    }

    /**
     * The column <code>public.empresa.empid</code>.
     */
    public final TableField<EmpresaRecord, Integer> EMPID = createField("empid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('empresa_empid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.empresa.empnome</code>.
     */
    public final TableField<EmpresaRecord, String> EMPNOME = createField("empnome", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.empresa.empcnpj</code>.
     */
    public final TableField<EmpresaRecord, String> EMPCNPJ = createField("empcnpj", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.empresa.emplocal</code>.
     */
    public final TableField<EmpresaRecord, String> EMPLOCAL = createField("emplocal", org.jooq.impl.SQLDataType.VARCHAR(100), this, "");

    /**
     * Create a <code>public.empresa</code> table reference
     */
    public Empresa() {
        this(DSL.name("empresa"), null);
    }

    /**
     * Create an aliased <code>public.empresa</code> table reference
     */
    public Empresa(String alias) {
        this(DSL.name(alias), EMPRESA);
    }

    /**
     * Create an aliased <code>public.empresa</code> table reference
     */
    public Empresa(Name alias) {
        this(alias, EMPRESA);
    }

    private Empresa(Name alias, Table<EmpresaRecord> aliased) {
        this(alias, aliased, null);
    }

    private Empresa(Name alias, Table<EmpresaRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.EMPRESA_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<EmpresaRecord, Integer> getIdentity() {
        return Keys.IDENTITY_EMPRESA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<EmpresaRecord> getPrimaryKey() {
        return Keys.EMPRESA_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<EmpresaRecord>> getKeys() {
        return Arrays.<UniqueKey<EmpresaRecord>>asList(Keys.EMPRESA_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Empresa as(String alias) {
        return new Empresa(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Empresa as(Name alias) {
        return new Empresa(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Empresa rename(String name) {
        return new Empresa(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Empresa rename(Name name) {
        return new Empresa(name, null);
    }
}
